/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#pragma once

#include <Base_Provider.h>
#include <unordered_map>
#include <librdkafka/rdkafkacpp.h>
#include <atomic>
#include <thread>
#include <Delivery_Report.h>


namespace inaf::oasbo::Providers {
class KafkaProvider : public BaseProvider{
protected:

	RdKafka::Producer *producer = nullptr;
	std::atomic<bool> stopFlag = false;
	std::thread pollThread;
	DeliveryReportCb *dr_cb = nullptr;


	void pollingThreadFunction();

	KafkaProvider();
	KafkaProvider(std::string ip, int port, std::string topic);

public:

	std::string brokerIp;
	int brokerPort;


	void setDest(std::string dest) override {this->dest = dest;}
	std::string getDest() override {return dest;}

	int write(PacketLib::BasePacket &) override;
	int write(PacketLib::BasePacket &, std::string dest) override;

	int close() override;
	int open() override;
	bool isOpen() override;
	~KafkaProvider();

	class Builder;
};
}
